﻿Public Class Form1

    Private Declare Auto Function FindWindow Lib "user32" _
    (ByVal ClassName As String, ByVal WindowTitle As String) As IntPtr

    Dim root As String
    Dim totalprgs As Integer
    Dim prglist As New List(Of String)
    Dim tmpprglist As New List(Of String)

    Function PCDStarted() As Boolean ' Check for PC-DMIS
        Dim lpclassname As String
        Dim PCD As Boolean

        lpclassname = "WilcoxAssociatesIncPC-DMISWndClass"
        PCD = True
        PCD = FindWindow(lpclassname, vbNullString)
        Return PCD
    End Function

    Private Function ListFiles() ' Lists all .PRG's found
        For Each PRG In prglist
            LogBox.AppendText(PRG & vbNewLine)
        Next
        LogBox.AppendText(vbNewLine & prglist.Count.ToString & " programs found.")
        If prglist.Count > 0 Then
            GoBtn.Enabled = True
        Else
            GoBtn.Enabled = False
        End If
    End Function

    Private Function GetAllFiles(ByVal strPath As String) As List(Of String)
        Dim lst As New List(Of String)
        Cursor = Cursors.WaitCursor
        Application.DoEvents()
        GetFiles(strPath, lst)
        prglist = tmpprglist.Distinct().ToList ' Sort the tmpPRGlist, remove duplicates
        ListFiles()
        Cursor = Cursors.Default
        Return lst
    End Function


    Public Sub GetFiles(ByVal strpath As String, ByRef lstfiles As List(Of String))
        Dim ext As String = ".prg"
        totalprgs = 0

        Try
            Dim str As String() = IO.Directory.GetFiles(strpath, "*.PRG", IO.SearchOption.TopDirectoryOnly)
            'Get Current Directory files

            lstfiles.AddRange(str)
            For Each PRG As String In lstfiles ' GetFiles lists all extensions that starts with .PRG (.PRG, .PRG~, .PRG^)
                If System.IO.Path.GetExtension(PRG).ToLower = ext Then ' This code will fix that and only look at the 8.3 extension
                    tmpprglist.Add(PRG) ' Put all .PRG in this temporary list (.PRG, .PRG^, .PRG~, .PRGwhatever)
                End If
            Next

            'Loop over sub-directories
            For Each strDirectory As String In IO.Directory.GetDirectories(strpath, "*.*", IO.SearchOption.TopDirectoryOnly)
                Me.GetFiles(strDirectory, lstfiles)
            Next

        Catch ex As UnauthorizedAccessException
            'Access Denied exception

        Catch ex1 As Exception
            'Other exceptions

        End Try
    End Sub

    Private Sub TextBox1_TextChanged(sender As Object, e As EventArgs) Handles LogBox.TextChanged
        Me.LogBox.ScrollToCaret() 'Scrolls the contents of the control to the current caret position.
    End Sub

    Private Sub BrwsBtn_Click(sender As Object, e As EventArgs) Handles BrwsBtn.Click
        If (FolderBrowserDialog1.ShowDialog() = DialogResult.OK) Then
            FolderBox.Text = FolderBrowserDialog1.SelectedPath
            root = FolderBrowserDialog1.SelectedPath
            Dim TestPath = root
            GetAllFiles(root) ' Get the PRG files
        End If
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        MessageBox.Show("You are running this program at your own risk!" & vbNewLine _
                        & vbNewLine & "-------------------------- Credits --------------------------" & vbNewLine _
                        & "PC-DMIS command code: Neil Challinor " & vbNewLine _
                        & ".NET adaptation: vpt.se" & vbNewLine _
                        & "Testing: bfire85" & vbNewLine _
                        & "-------------------------------------------------------------" & vbNewLine _
                        & vbNewLine & "Click OK if you have understood that the author/s cannot" _
                        & vbNewLine & "be liable for any damages caused by using this program.")
        If Not PCDStarted() Then
            MessageBox.Show("PC-DMIS must be started for this to work!")
        End If
    End Sub

    Private Sub GoBtn_Click(sender As Object, e As EventArgs) Handles GoBtn.Click
        ' Code for replacing GETTEXT() by Neil Challinor (neil.challinor @ PC-DMIS Users Forum)
        Dim App As PCDLRN.Application
        Dim Part As PCDLRN.PartProgram
        Dim Cmds As PCDLRN.Commands
        Dim Cmd As PCDLRN.Command
        Dim Programs As PCDLRN.PartPrograms
        Dim GeoTol_Cmd, VarStr, NewStr, FeatNum As String
        Dim VarIsNum, DimIsGeotol, found, shouldwrite As Boolean
        Dim i As Integer
        Dim convlist As New List(Of String)

        If PCDStarted() Then
            App = CreateObject("PCDLRN.Application")
            App.WaitUntilReady(60) ' Important! Otherwise "Object not set"
            System.Threading.Thread.Sleep(2000) ' Important! Otherwise "Object not set"
            Programs = App.PartPrograms

            If Programs.Count <> 0 Then
                MessageBox.Show("Please close all PC-DMIS part programs!")
                Exit Sub
            End If

            If Invisible.Checked = True Then
                App.Visible = False
            ElseIf Invisible.Checked = False Then
                App.Visible = True
            End If

            For Each PRG In prglist
                LogBox.AppendText("[o] " & PRG & vbNewLine)
                Programs.Open(PRG, "CMM1")
                Part = App.ActivePartProgram
                Cmds = Part.Commands
                found = False
                DimIsGeotol = False ' bfire85 edition

                For i = 1 To Cmds.Count
                    ' Code by Neil Challinor start
                    ' Adaptations for VB.Net by vpt.se
                    ' bfire85 edition
                    VarIsNum = False
                    Cmd = Cmds.Item(i)

                    If Cmd.Type = 1302 Or Cmd.Type = 1303 Then ' If command is GeoTol (ASME or ISO)
                        DimIsGeotol = True
                        GeoTol_Cmd = Cmd.GetText(2, 0) ' Grab geometric tolerance command ID
                        Cmds.InsertionPointAfter(Cmd)
                        Cmd = Cmds.Add(195, True)
                        Cmd.Marked = True
                        Cmd.PutText("DPTR", 133, 0)
                        Cmd.PutText(Chr(123) & GeoTol_Cmd & Chr(125), 134, 0) ' create a pointer assignment referencing ID (handles ID being purely numeric)
                        GoTo 1
                    End If

                    If Cmd.IsDimension Then ' bfire85 edition
                        DimIsGeotol = False
                    End If

                    If Cmd.Type = 195 = True And DimIsGeotol Then ' If command is an assignment
                        VarStr = Cmd.GetText(134, 0) ' grab RH expression String

                        If InStr(1, VarStr, "GETTEXT(662,") <> 0 Then ' If GETTEXT is grabbing the deviation - bfire85 edition
                            FeatNum = Strings.Right(VarStr, Len(VarStr) - InStr(1, VarStr, "662" & Chr(44)) - 3) ' Grab feature number being referenced - bfire85 edition
                            FeatNum = Strings.Left(FeatNum, InStr(1, FeatNum, Chr(44)) - 1) ' Grab feature number being referenced
                            FeatNum = FeatNum.Trim()
                            NewStr = Strings.Left(FeatNum, InStr(1, VarStr, "GETTEXT") - 1) ' Remove GETTEXT Or assignment
                            NewStr = NewStr & "DPTR.SEGMENT[1].FEATURE[" & FeatNum & "].DEV" & Chr(43) & Chr(34) ' Replace GETTEXT statement With new syntax
                            found = True
                            DimIsGeotol = False
                        End If

                        If InStr(1, VarStr, "GETTEXT(688,") <> 0 Then ' If GETTEXT is grabbing the measured result - bfire85 edition
                            FeatNum = Strings.Right(VarStr, Len(VarStr) - InStr(1, VarStr, "688" & Chr(44)) - 3) ' Grab feature number being referenced - bfire85 edition
                            FeatNum = Strings.Left(FeatNum, InStr(1, FeatNum, Chr(44)) - 1) ' Grab feature number being referenced
                            FeatNum = FeatNum.Trim()
                            NewStr = Strings.Left(FeatNum, InStr(1, VarStr, "GETTEXT") - 1) ' Remove GETTEXT Or assignment
                            NewStr = NewStr & "DPTR.SEGMENT[1].FEATURE[" & FeatNum & "].MEAS" & Chr(43) & Chr(34) ' Replace GETTEXT statement With new syntax
                            found = True
                            DimIsGeotol = False
                        End If

                        If InStr(1, VarStr, "GETTEXT(328,") <> 0 Then ' If GETTEXT is grabbing the measured result (from a form tolerance) - bfire85 edition
                            FeatNum = Strings.Right(VarStr, Len(VarStr) - InStr(1, VarStr, "328" & Chr(44)) - 3) ' Grab feature number being referenced - bfire85 edition
                            FeatNum = Strings.Left(FeatNum, InStr(1, FeatNum, Chr(44)) - 1) ' Grab feature number being referenced
                            FeatNum = FeatNum.Trim()
                            NewStr = Strings.Left(FeatNum, InStr(1, VarStr, "GETTEXT") - 1) ' Remove GETTEXT Or assignment
                            NewStr = NewStr & "DPTR.SEGMENT[1].FEATURE[" & FeatNum & "].MEAS" & Chr(43) & Chr(34) ' Replace GETTEXT statement With new syntax
                            found = True
                            DimIsGeotol = False
                        End If
                        Cmd.PutText(NewStr, 134, 0)
                        Cmd.ReDraw()
                    End If
                    ' Code by Neil Challinor end
1:
                Next

                If found And Not Overwrite.Checked Then
                    convlist.Add(Part.Name & " converted to " & Part.Path & "CONV_" & Part.Name)
                    LogBox.AppendText("[s] " & "CONV_" & Part.Name & vbNewLine)
                    Part.SaveAs(Part.Path & "CONV_" & Part.Name)
                    LogBox.AppendText("[cl] " & Part.Name & vbNewLine)
                    Part.Quit()
                    shouldwrite = True
                ElseIf found And Overwrite.Checked Then
                    convlist.Add(Part.Name & " overwritten.")
                    LogBox.AppendText("[s] " & Part.Name & vbNewLine)
                    Part.SaveAs(Part.Path & Part.Name)
                    LogBox.AppendText("[cl] " & Part.Name & vbNewLine)
                    Part.Quit()
                    shouldwrite = True
                Else
                    LogBox.AppendText("Criteria not found, no changes made." & vbNewLine)
                    LogBox.AppendText("[q] " & Part.Name & vbNewLine)
                    Part.Quit()
                End If
            Next
            LogBox.AppendText(convlist.Count & " programs converted.")
            If shouldwrite Then
                System.IO.File.WriteAllLines("converted programs.txt", convlist)
                LogBox.AppendText("Overview of converted programs written to 'converted programs.txt'.")
            End If
            If App.Visible = False Then
                App.Visible = True
            End If
        Else
            MessageBox.Show("PC-DMIS must be started for this to work!")
            Exit Sub
        End If
    End Sub

    Private Sub HelpBtn_Click(sender As Object, e As EventArgs) Handles HelpBtn.Click
        MsgBox("This utility was developed to assist PC-DMIS users during the transition to PC-DMIS 2020 R2." & vbNewLine _
        & "2020 R2 introduced the Geometric Tolerance command, which is not compatible with the GETTEXT() command." & vbNewLine _
        & "This utility will convert a program's GETTEXT() commands into commands that are compatible with 2020 R2." & vbNewLine _
        & vbNewLine _
        & "Directions for use: " & vbNewLine _
        & "- Open PC-DMIS (PC-DMIS must be running during the conversion)." & vbNewLine _
        & "- Choose the directory containing the program(s) requiring conversion." & vbNewLine _
        & "- Choose from the two checkbox options: " & vbNewLine _
        & vbTab & "1. 'Overwrite?' - This checkbox, if selected, will allow the " & vbNewLine _
        & vbTab & "application to overwrite your program after conversion. You " & vbNewLine _
        & vbTab & "should only select this option if you are not planning on " & vbNewLine _
        & vbTab & "running a version of PC-DMIS older than 2020 R2." & vbNewLine _
        & vbTab & "2. 'Invisible Mode' - This checkbox, if selected, will allow " & vbNewLine _
        & vbTab & "PC-DMIS to perform the conversion process in invisible " & vbNewLine _
        & vbTab & "mode. You will not see the PC-DMIS window as it cycles " & vbNewLine _
        & vbTab & "through your programs. This method is faster." & vbNewLine _
        & "- Press the 'Go!' button.", 64, "Information")
    End Sub
End Class
